/*
THIS CODE IS STILL IN PROGRESS!

Open up the serial console on the Arduino at 115200 baud to interact with FONA

Note that if you need to set a GPRS APN, username, and password scroll down to
the commented section below at the end of the setup() function.
*/
#include <ad5420.h>

/*
Use the 6 pin SPI connector on arduino DUE board (NOT the ICSP!)
The pin 1 has a white dot behind it.
  MOSI: 
  MISO: 
  SCLK: 
  CS: on SPI extended mode can use only PIN 4,10,52 !!!
*/

#define AD5420_FAULT  8
#define AD5420_CLEAR  9
#define AD5420_LATCH 10

DAC_AD5420  dac_ad5420 = DAC_AD5420(AD5420_LATCH, AD5420_CLEAR, AD5420_FAULT);

void setup()
{
    Serial.begin(115200);
    Serial.println("AD5420_test start!");
    Serial.print("_latch = ");
    Serial.println(dac_ad5420._latch);
    Serial.print("_clear = ");
    Serial.println(dac_ad5420._clear);
    Serial.print("_fault = ");
    Serial.println(dac_ad5420._fault);

    dac_ad5420.begin();
    delay(100);
    dac_ad5420.ad5420_reset();
    delay(100);

    dac_ad5420.ad5420_write_ctrl(AD5420_OUTEN | AD5420_REXT | AD5420_0_20_RANGE);
    dac_ad5420.ad5420_write_data(0x2000);
}


void loop()
{
    Serial.print("Get_Status: ");
    Serial.println(dac_ad5420.ad5420_get_status(), HEX);
  
    Serial.print("Status_Reg: ");
    Serial.println(dac_ad5420.ad5420_read_reg(AD5420_STATUS_REG),  HEX);
    Serial.print("Data_Reg: ");
    Serial.println(dac_ad5420.ad5420_read_reg(AD5420_DATA_REG),    HEX);
    Serial.print("Control_Reg: ");
    Serial.println(dac_ad5420.ad5420_read_reg(AD5420_CONTROL_REG), HEX);

    delay(1000);
}
